/* Example from Quick Python pg. 276 */
#include "Python.h"

static PyObject * example_makelist(PyObject *self, PyObject *args)
{
	PyObject *argument, *list;
	/* Parse out the single argument as a C pointer to a Python object */
	if (!PyArg_ParseTuple(args, "O", &argument))
	{
		return NULL;
	}

	/* Create a new two-element list. */
	list= PyList_New(2);
	
	/* Set the first element of the new list to point to the argument passed
	this function.  This means a new (nontemporary) reference to the argument
	has been created, so increment its reference count */
	PyList_SetItem(list, 0, argument);
	Py_INCREF(argument);
	
	/* set the second element of the new list to point to the function argument
	and increment the reference count of the argument again */
	PyList_SetItem(list, 1, argument);
	Py_INCREF(argument);
	
	/* Now build and return the new list */
	return Py_BuildValue("O", list);
}

	
static PyMethodDef example_methods[] =
{
	{"makelist", example_makelist, 1,
		 "This function returns a list of two references to the argument"},
	{NULL, NULL}
};

/* This line added by GW hammond does this*/
__declspec(dllexport)

void example_init()
{
	Py_InitModule("example", example_methods);
}
	
